﻿
using System;
using System.Drawing;
using Wisej.Web;

namespace WiseJTestGridColumnWidthChanged
{
    public partial class Window1 : Form
    {
        public Window1()
        {
            InitializeComponent();

            grdTest.ColumnWidthChanged += evtGrid_ColumnWidthChanged;
        }

        private void evtForm_Load(object sender, EventArgs e)
        {
            SetupGrid(grdTest, 2, false, 24, DataGridViewEditMode.EditProgrammatically);

            AddColumn2Grid_TextBoxColumn(grdTest, "Test1", "Test 1", false, DataGridViewContentAlignment.TopCenter, false, true, 0);
            AddColumn2Grid_TextBoxColumn(grdTest, "Test2", "Test 2", false, DataGridViewContentAlignment.TopCenter, false, true, 0);
            AddColumn2Grid_TextBoxColumn(grdTest, "Test3", "Test 3", false, DataGridViewContentAlignment.TopCenter, false, true, 0);
            AddColumn2Grid_TextBoxColumn(grdTest, "Test4", "Test 4", false, DataGridViewContentAlignment.TopCenter, false, true, 0);
            AddColumn2Grid_TextBoxColumn(grdTest, "Test5", "Test 5", false, DataGridViewContentAlignment.TopCenter, false, true, 0);

            this.WindowState = FormWindowState.Maximized;
        }

        private void evtGrid_ColumnWidthChanged(object sender, DataGridViewColumnEventArgs e)
        {
            AlertBox.Show("Columm " + e.Column.Name + " width changed", MessageBoxIcon.Information, null, ContentAlignment.TopRight);
        }

        private void SetupGrid(DataGridView grd2Use, int iHeaderLines, bool bAutoSizeRows, int iDefaultRowHeight = 24, DataGridViewEditMode dgvEditMode = DataGridViewEditMode.EditProgrammatically)
        {
            grd2Use.EditMode = dgvEditMode;
            grd2Use.VirtualMode = false;
            grd2Use.RowCount = 0;
            grd2Use.ColumnCount = 0;
            grd2Use.MultiSelect = false;
            grd2Use.ShowColumnVisibilityMenu = false;
            grd2Use.ShowCellToolTips = true;
            grd2Use.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DoubleClick;
            grd2Use.DefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Regular);

            switch (iHeaderLines)
            {
                case 0: grd2Use.ColumnHeadersVisible = false; break;
                case -1: grd2Use.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.AutoSize; break;
                default:
                    grd2Use.ColumnHeadersHeight = (26 * iHeaderLines);
                    break;
            }

            grd2Use.ColumnHeadersDefaultCellStyle.WrapMode = DataGridViewTriState.True;

            grd2Use.DefaultCellStyle.Padding = new Padding(2, 4, 2, 2);
            if (iDefaultRowHeight > 0) { grd2Use.DefaultRowHeight = iDefaultRowHeight; }

            if (bAutoSizeRows) grd2Use.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCellsExceptHeaders;
        }

        private DataGridViewTextBoxColumn AddColumn2Grid_TextBoxColumn(DataGridView grd2Use, string pColName, string pColTitle, bool pUseHTML, DataGridViewContentAlignment pAlign, bool pWrapText, bool pReadOnly, int pMaxInputLen = 0)
        {
            DataGridViewTextBoxColumn col2Add = new DataGridViewTextBoxColumn();
            col2Add.Name = pColName;
            col2Add.HeaderText = pColTitle;
            col2Add.AllowHtml = pUseHTML;
            col2Add.DefaultCellStyle.Alignment = pAlign;
            col2Add.DefaultCellStyle.WrapMode = (pWrapText ? DataGridViewTriState.True : DataGridViewTriState.False);
            col2Add.ReadOnly = pReadOnly;
            col2Add.Resizable = DataGridViewTriState.True;
            col2Add.SortMode = DataGridViewColumnSortMode.Automatic;
            col2Add.MaxInputLength = pMaxInputLen;

            grd2Use.Columns.Add(col2Add);

            return col2Add;
        }

    }
}
